<template>
  <div class="promo-form">
    <template v-if="step === 1">
      <div class="promo-form__row">
        <div class="promo-form__row-title">
          <i class="icon route-loading -diamond-orange-yellow" />
          <b> Погрузка</b>
        </div>
        <ObAddressInput
          title="Адрес"
          :address="addressFrom.label"
          :prefixIcon="addressFrom.icon || ''"
          :locationsTypes="locationsTypes"
          placeholder="Например, Мосфильмовская ул., 17, Москва, Россия, 119590"
          required
          :showMap="false"
          data-qa="addressFrom"
          @input="setAddress($event, 'FROM')"
          @on-change-address="setAddress($event, 'FROM')"
        />
        <div class="order-route__base" v-if="addressFrom.locationTitle">
          Относится к опорному пункту:
          <span>{{ addressFrom.locationTitle }}</span>
        </div>
      </div>
      <div class="promo-form__row">
        <div class="promo-form__row-title">
          <i class="icon route-unloading -green-700" />
          <b> Разгрузка</b>
        </div>
        <ObAddressInput
          title="Адрес"
          :address="addressTo.label"
          :prefixIcon="addressTo.icon || ''"
          :locationsTypes="locationsTypes"
          placeholder="Например, Мосфильмовская ул., 17, Москва, Россия, 119590"
          required
          :showMap="false"
          data-qa="addressTo"
          @input="setAddress($event, 'TO')"
          @on-change-address="setAddress($event, 'TO')"
        />
        <div class="order-route__base" v-if="addressTo.locationTitle">
          Относится к опорному пункту:
          <span>{{ addressFrom.locationTitle }}</span>
        </div>
      </div>
      <div class="promo-form__row">
        <div class="promo-form__row-title">
          Тип автотранспорта
        </div>
        <ob-select
          v-model="formData.bodySaveDraft.serviceParams.serviceUuid"
          class="transport-type-select"
          label="Тип автотранспорта"
          :items="transportTypes"
          placeholder="Выберите из списка"
          position="top"
          :isStandart="true"
          required
          @input="onTransportChanged"
        />
      </div>
      <div class="promo-form__row">
        <ob-button label="Узнать цену" isFullWidth :disabled="!isRouteValid || !istransportValid || isSaving || isSearchingPrice || isError" @click="onSubmit" />
      </div>
    </template>
    <template v-if="step === 2">
      <div class="promo-form__preview-row">
        <div class="promo-form__preview__title">Погрузка</div>
          <div class="promo-form__preview-item">
            <i class="icon route-loading -diamond-orange-yellow"></i>
            {{ addressFrom.label }}
          </div>
      </div>

      <div class="promo-form__preview-row">
        <div class="promo-form__preview__title">Разгрузка</div>
          <div class="promo-form__preview-item">
            <i class="icon route-unloading -green-700"></i>
            {{ addressTo.label }}
          </div>
      </div>

      <div class="promo-form__preview-row">
        <div class="promo-form__preview__title">Тип автотранспорта</div>
          <div class="promo-form__preview-item">
            {{ selectedTransport.title }}.
          </div>
      </div>

      <div class="promo-form__preview-row promo-form__preview-row--edit">
        <span @click="onEdit">
          <i class="icon edit"></i>
          Изменить данные
        </span>
      </div>

      <div class="promo-form__preview-price" v-if="!isError">
        <div class="promo-form__preview-price-label">
          <i class="icon checked"></i>
          Стоимость перевозки*
        </div>
        <div class="promo-form__preview-price-info">
          <div class="promo-form__preview-price-summ">
            <ob-currency :value="logchain.total_price / 100" />
            <span>без НДС</span>
          </div>
          <div class="promo-form__preview-price-vat">
            НДС:
            <ob-currency
              :value="
                ((logchain.total_price / 100) * logchain.vat) / 100
              "
            />
          </div>
        </div>
        <div class="promo-form__preview-route-info">
          <div class="route-length">
            {{ routeLength }},
            <ob-currency :value="(logchain.total_price / logchain.route_length_in_m) * 10 " />/км
          </div>
          <div class="route-duration">
            {{ routeDuration }}
          </div>
        </div>
      </div>

      <div class="promo-form__preview-error" v-if="isError">
        <div class="promo-form__preview-error-title">
          <i class="icon call-center"></i>
          Мы не смогли автоматически обработать ваш запрос, у нас нет информации по заданному направлению, измените вводные данные и попробуйте снова
        </div>
      </div>
    </template>
  </div>
</template>

<script>
import { uuid } from "vue-uuid";
import { mapGetters } from "vuex";
import { orderInitData } from "@/resources/order";
import api from "@/api";
import ObAddressInput from "common-components/src/obComponents/obAddressInput";
import obSelect from 'common-components/src/obComponents/obSelect';
import obButton from 'common-components/src/obComponents/obButton';
import obCurrency from "@/components/obCurrency";

export default {
  name: "promo",

  components: {
    ObAddressInput,
    obSelect,
    obButton,
    obCurrency
  },

  async created() {
    try {
      await this.getLocationsTypes();
      await this.getServicesForSimpleOrders();
    } catch (e) {
      console.error(e);
    }
  },

  async mounted() {
    try {
      const newUUID = uuid.v4();
      this.orderUuid = newUUID;
      const number = await api.orders.getOrderId('Order');
      this.formData.creators = {
        userUuid: this.userUuid,
        contractorUuid: this.contractorUuid,
      };
      this.formData.bodySaveDraft.number = number.data.code;
      const contractor = await api.orders.getParticipantForAnonymous();
      this.formData.bodySaveDraft.contractorUuid = contractor.uuid;
      this.formData.bodySaveDraft.serviceParams.serviceTypeUuid = '56eaa734-ad65-47e2-b961-80797818e935'
      const { notAuthorized: settings } = await api.orders.getAnonymousSettings(
        contractor.uuid,
        "NOT_AUTHORIZED"
      );
      this.formData.bodySaveDraft.orderType = "STANDARD";
      this.formData.bodySaveDraft.clientUuid = this.contractorUuid;
      this.formData.parameters.cargoTypeUuid = settings.cargoTypeUuid;
      this.formData.parameters.insuranceCargo.cost = settings.insuranceCost;
      const date = new Date();
      date.setDate(date.getDate() + 1);
      date.setHours(12, 0, 0);
      this.formData.bodySaveDraft.route.departureDt = date;
      await this.saveOrder();
    } catch (e) {
      console.error(e);
    }
  },

  data() {
    return {
      formData: orderInitData,
      addressFrom: {
        coordinates: {},
        icon: "pin",
        label: "",
        isValid: true,
        popoverMessage: "",
        locationTitle: "",
        orderUuid: null
      },
      addressTo: {
        coordinates: {},
        icon: "pin",
        label: "",
        isValid: true,
        popoverMessage: "",
        locationTitle: ""
      },
      locationsTypes: null,
      transportTypes: [],
      isSaving: false,
      isSearchingPrice: false,
      isError: false,
      logchain: null,
      step: 1
    }
  },

  computed: {
    ...mapGetters({
      userUuid: "user/userUuid",
      contractorUuid: "user/participantUuid",
    }),
    routeLength () {
      return this.logchain.route_length_in_m ? this.getLength(this.logchain.route_length_in_m) + 'км' : '0 км'
    },
    routeDuration () {
      return this.logchain.route_duration_in_sec ? this.getDuration(this.logchain.route_duration_in_sec) : '0 дней'
    },
    selectedTransport() {
      const transport = this.transportTypes.find(item => item.uuid === this.formData.bodySaveDraft.serviceParams.serviceUuid);
      return transport;
    },
    hasAddressFrom() {
      return !!this.addressFrom.label && this.addressFrom.isValid;
    },
    hasAddressTo() {
      return !!this.addressTo.label && this.addressTo.isValid;
    },
    isRouteValid() {
      return this.hasAddressFrom && this.hasAddressTo;
    },
    istransportValid() {
      return !!this.formData.bodySaveDraft.serviceParams.serviceUuid;
    },
  },

  methods: {
    onEdit() {
      this.step = 1;
      this.logchain = {};
      this.isError = false;
    },
    getLength(value) {
      return Math.ceil(value / 1000);
    },
    getDuration(duration) {
      const fm = [
        Math.floor(duration / (3600 * 24)),
        Math.ceil((duration % (3600 * 24)) / 3600)
      ];
      return fm
        .map((v, i) => {
          if (v) {
            if (i === 0) {
              v = this.plural(v, "день | дня | дней");
            } else if (i === 1) {
              v = this.plural(v, "час | часа | часов");
            } else if (i === 2) {
              v = this.plural(v, "минута| минуты | минут");
            } else if (i === 3) {
              v = this.plural(v, "секунда | секунды | секунд");
            }
            return v;
          }
        })
        .join(" ");
    },
    plural(value, unit) {
      return value + this.declOfNum(value, unit);
    },

    declOfNum(n, string) {
      let titles = string.split("|");
      return titles[
        n % 10 == 1 && n % 100 != 11
          ? 0
          : n % 10 >= 2 && n % 10 <= 4 && (n % 100 < 10 || n % 100 >= 20)
          ? 1
          : 2
      ];
    },
    async findPrice() {
      try {
        const transactionUuid = uuid.v4();
        const logchains = await api.orders.findLogchains({
          draftUuid: this.orderUuid,
          transactionUuid,
          userUuid: this.userUuid,
        });

        this.logchain = logchains.logchains[0].main_data;
        this.foundLogchain = logchains.logchains[0].main_data.uuid
      } catch (e) {
        this.isError = true;
      }
    },
    async onSubmit() {
      this.isSaving = true;
      this.isSearchingPrice = true;
      try {
        await api.orders.resetSnapshots(this.orderUuid);
        const validation = await api.orders.checkContinueFirst(this.orderUuid);
        if (validation.status) {
          await api.orders.createGoGp(this.orderUuid);
          await this.findPrice();
          this.isSaving = false;
          this.isSearchingPrice = false;
          this.step = 2;
        } else {
          this.isSaving = false;
          this.isSearchingPrice = false;
          this.isError = true;
        }
      } catch (err) {
        console.error(err);
      }
    },
    async getServicesForSimpleOrders() {
      try {
        const res = await api.orders.getServicesForSimpleOrders("FTL");
        const filteredData = res.reduce((acc, item) => {
          const temp = item.services.filter(service => service.showForAnonymous)
          acc.push(...temp)
          return acc;
        }, [])
        const data = [];
        filteredData.forEach(element => {
          data.push({
            title: `${element.resourceTitle} ${element.resourcePattern}`,
            uuid: element.serviceUuid,
            serviceTypeUuid: element.serviceTypeUuid || '56eaa734-ad65-47e2-b961-80797818e935'
          })
        });
        this.transportTypes = data;
      } catch (err) {
        console.error(err);
      }
    },
    async onTransportChanged($event) {
      const transport = this.transportTypes.find(item => item.uuid === $event);
      if (transport) {
        this.formData.bodySaveDraft.serviceParams.serviceTypeUuid = transport.serviceTypeUuid;
      }
      await this.saveOrder();
    },
    async setAddress($event, direction) {
      let ext = ''
      if (direction === 'FROM') {
        ext = 'From'
      } else {
        ext = 'To'
      }
      this[`address${ext}`] = $event;
      this[`address${ext}`].isValid =
        !!this[`address${ext}`].coordinates.lat &&
        !!this[`address${ext}`].coordinates.lon;
      if (!this[`address${ext}`].isValid) {
        this[`address${ext}`].popoverMessage =
          "Адрес не найден. Выберите существующий адрес из списка или укажите точку на карте";
        return false;
      }
      if (!$event.icon) {
        this[`address${ext}`].icon = "pin";
      }

      const point = this.formData.bodySaveDraft.route.points.find(
        (item) => item.direction === direction
      );

      if (this[`address${ext}`].icon && this[`address${ext}`].icon == "city-sm") {
        // опорная точка
        point.type = "REFERENCE_POSITION";
      } else if (
        this[`address${ext}`].icon &&
        this[`address${ext}`].icon !== "city-sm" &&
        this[`address${ext}`].icon !== "pin"
      ) {
        point.type = "INFRASTRUCTURE_FACILITY";
      } else {
        // не опорная точка
        point.type = "ADDRESS";
      }

      const newPoint = {
        countryCode: "RUS",
        coordinates: this[`address${ext}`].coordinates,
        locationUuid: this[`address${ext}`].locationUuid || "",
        locationTypeUuid: this[`address${ext}`].location_type_uuid || "",
        addressTitle: this[`address${ext}`].label || "",
      };
      point.params = { ...point.params, ...newPoint };
      point.visitPointCount = 1;
      await this.saveRoute(this.orderUuid, this.formData.bodySaveDraft.route);
      await this.saveOrder();
    },

    async getLocationsTypes() {
      try {
        const res = await api.locations.getLocationTypes()
        this.locationsTypes = res.data.content;
      } catch (err) {
        console.error(err);
      }
    },
    async saveRoute(uuid, route) {
      try {
        const res = await api.orders.saveRoute(uuid, route)
        this.formData.bodySaveDraft.route.transboundary = res.transboundary
      } catch (err) {
        console.error(err);
        this.$notification({
          type: "system_notification_error",
          message: "Ошибка сохранения маршрута",
        });
      }
    },

    async saveOrder() {
      try {
        await api.orders.saveOrder(this.orderUuid, this.formData);
        await this.saveRoute(this.orderUuid, this.formData.bodySaveDraft.route);
      } catch (e) {
        console.error(e);
      }
    }
  }
};
</script>

<style lang="scss" scoped>
@import "~common-components/src/static/css/mixins";
@import "~common-components/src/assets/style/ob-style";

.promo-form {
  width: 100%;
  max-width: 830px;
  padding: 40px;
  margin: 40px auto;
  background-color:white;
  box-shadow: 0px 0px 2px rgba(0, 75, 200, 0.15), 0px 0px 12px rgba(0, 75, 200, 0.04), 0px 4px 10px rgba(0, 75, 200, 0.06);
  border-radius: 4px;
  align-self: flex-start;
}

.promo-form__row:not(:last-child) {
  margin-bottom: 30px;
}

.promo-form__row-title {
  margin-bottom: 10px;
  @include font-mixin(16px, 20px, 700, $color-text-base);

  .icon {
    margin-right: 5px;
  }
}

.promo-form__preview-row:not(:last-child) {
  margin-bottom: 10px;
}

.promo-form__preview-row--edit {
  margin-top: 35px;
  color: $blue-700;

  span {
    cursor: pointer;
  }
}

.promo-form__preview__title {
  @include font-mixin(12px, 22px, 400, $gray-slate);
  margin-bottom: 5px;
}

.promo-form__preview-item {
  @include font-mixin(16px, 20px, 400, $color-text-base);

  .icon {
    margin-right: 5px;
  }
}

.promo-form__preview-price {
  margin-top: 30px;
  padding: 20px 40px 20px 20px;
  display: flex;
  align-items: center;
  justify-content: space-between;
  border: 1px solid $blue-700;
  box-shadow: 0px 0px 2px rgba(0, 75, 200, 0.15), 0px 0px 12px rgba(0, 75, 200, 0.04), 0px 4px 10px rgba(0, 75, 200, 0.06);
  border-radius: 20px;
}

.promo-form__preview-price-label {
  display: flex;
  align-items: center;
  @include font-mixin(16px, 20px, 700, $color-text-base);

  .icon {
    margin-right: 10px;
    color: $color-green-light;
    font-size: 24px;
  }
}

.promo-form__preview-price-info {
  @include font-mixin(12px, 1, 400, $gray-slate);
}

.promo-form__preview-price-summ {
  display: flex;
  align-items: flex-end;
  @include font-mixin(16px, 1, 700, $color-text-base);
  
  span {
    margin-left: 5px;
    @include font-mixin(12px, 1, 400, $color-text-base);
  }

  &::v-deep {
    .currency {
      font-weight: 700;
    }
  }
}

.promo-form__preview-price-vat {
  display: flex;
  margin-top: 5px;

  &::v-deep {
    .currency {
      margin-left: 5px;
      font-weight: 700;
    }
  }
}

.promo-form__preview-error {
  margin-top: 30px;
  margin-bottom: 30px;
  padding: 20px 40px 20px 20px;
  border: 1px solid $diamond-orange-yellow;
  box-shadow: 0px 0px 2px rgba(0, 75, 200, 0.15), 0px 0px 12px rgba(0, 75, 200, 0.04), 0px 4px 10px rgba(0, 75, 200, 0.06);
  border-radius: 20px;

  p {
    @include font-mixin(14px, 16px, 400, $gray-slate);
  }

  a {
    text-decoration: none;
    color: #0071AB;
  }
}

.promo-form__preview-error-title {
  display: flex;
  margin-bottom: 15px;
  @include font-mixin(16px, 20px, 700, $color-text-base);

  .icon {
    margin-right: 15px;
    font-size: 22px;
    color: $diamond-orange-yellow;
  }
}

.promo-form__preview-error-text {
  padding-left: 37px;

  p + p {
    margin-top: 15px;
  }
  
  span {
    color: $color-text-base;
  }
}

.promo-form__legal {
  margin-bottom: 30px;
  @include font-mixin(12px, 12px, 400, $gray-slate);
}

.promo-form__preview-route-info {
  @include font-mixin(12px, 14px, 400, $gray-slate);
}

.route-length {
  margin-bottom: 1em;
  display: flex;
  align-items: flex-end;

  .currency {
    margin-left: 0.5em;
  }
}
</style>